#
# spec file for package tgt
#
# Copyright (c) 2015 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           tgt
BuildRequires:  docbook-xsl-stylesheets
BuildRequires:  libaio-devel
BuildRequires:  libxslt
BuildRequires:  openssl-devel
BuildRequires:  perl-Config-General
BuildRequires:  systemd
BuildRequires:  systemd-devel
BuildRequires:  pkgconfig(systemd)
Obsoletes:      iscsitarget
Requires:       perl-Config-General
Url:            http://stgt.berlios.de
Requires(pre):  %fillup_prereq
Version:        1.0.44
Release:        12.1
%{?systemd_requires}
Summary:        Generic Linux target framework (tgt)
License:        GPL-2.0
Group:          System/Daemons
Source:         %{name}-%{version}.tar.bz2
Source1:        %{name}d.service
Source3:        %{name}.services
Source4:        sysconfig.%{name}
Patch1:         %{name}-git-update
Patch2:         %{name}-fix-build
Patch3:         setup-tgt-conf-d.patch
Patch4:         %{name}-systemd-notification-support
Patch5:         %{name}-fix-libs-for-current-systemd-linker-name
Patch6:         %{name}-handle-access-of-a-target-that-has-been-removed
Patch7:         %{name}-missing-module-directory-not-an-error 

%description
Linux target framework (tgt) aims to simplify various SCSI target
driver (iSCSI, Fibre Channel, SRP, etc) creation and maintenance.

Tgt consists of kernel modules, user-space daemon, and user-space
tools. Some target drivers uses all of them and some use only
user-space daemon and tools (i.e. they completely runs in user space).



Authors:
--------
    FUJITA Tomonori <fujita.tomonori@lab.ntt.co.jp>
    Mike Christie <michaelc@cs.wisc.edu>

%prep
%setup -n %{name}-%{version}
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1

%build
%ifarch ppc ppc64 ppc64le
%define backends ISCSI=1 FCP=1 FCOE=1 IBMVIO=1 SD_NOTIFY=1
%else
%define backends ISCSI=1 FCP=1 FCOE=1 SD_NOTIFY=1
%endif
%{__make} OPTFLAGS="${RPM_OPT_FLAGS}" %{backends}

%install
%{__make} DESTDIR=%{buildroot} docdir=%_docdir/%{name} install
install -vD -m 644 %{S:1} %{buildroot}/%{_unitdir}/%{name}d.service
install -vD %{S:3} %{buildroot}/etc/sysconfig/SuSEfirewall2.d/services/tgt
install -vD %{S:4} %{buildroot}/var/adm/fillup-templates/sysconfig.%{name}
ln -sf service %{buildroot}/%{_sbindir}/rc%{name}d

%pre
%service_add_pre %{name}d.service

%post
%{fillup_only}
%service_add_post %{name}d.service

%preun
%service_del_preun %{name}d.service

%postun
%service_del_postun %{name}d.service

%files
%defattr(-,root,root)
%{_sbindir}/*
%dir /etc/tgt
%dir /etc/tgt/conf.d
%config %attr(0644,root,root) /etc/tgt/targets.conf
%config %attr(0644,root,root) /etc/sysconfig/SuSEfirewall2.d/services/tgt
/var/adm/fillup-templates/sysconfig.tgt
%{_unitdir}/%{name}d.service
%doc README doc/README.iscsi doc/README.iser doc/README.lu_configuration
%doc doc/README.mmc doc/README.passthrough doc/README.sbcjukebox doc/README.ssc
%doc %{_mandir}/man8/*

%changelog
* Mon Nov 16 2015 lduncan@suse.com
- Adding upstream patch to silence bogus error
  message when backing-store directory not present
  (bsc#954801), adding patch:
  * tgt-missing-module-directory-not-an-error
* Mon Nov 16 2015 lduncan@suse.com
- Added upstream patch to handle possible target removal
  while accessing it (bsc#922526), adding patch:
  * tgt-handle-access-of-a-target-that-has-been-removed
* Thu Oct 22 2015 lduncan@suse.com
- Updating to synchronize with systemd on startup
  (bsc#950946), adding two upstream patches:
  * tgt-systemd-notification-support
  * tgt-fix-libs-for-current-systemd-linker-name
* Tue Oct 13 2015 lduncan@suse.com
- Update systemd service file, based on the
  latest upstream (bsc#949468)
- Remove duplicate inclusion of target configuration
  from /etc/tgt/conf.d in /etc/tgt/targets.conf,
  modifying patch setup-tgt-conf.d.patch
* Sun Sep 13 2015 ddiss@suse.com
- Fix rctgtd systemd service symlink. (bnc#945604)
* Thu Sep 10 2015 bwiedemann@suse.com
- Allow to add options via sysconfig. (bnc#828214)
- Drop invalid ExecStopPre entry. (bsc#947346)
* Fri Jun 26 2015 bwiedemann@suse.com
- fix tgtd start by giving tgtd time to open the socket (bnc#934642)
  and use bash to run multiple programs in ExecStartPost
* Wed May 14 2014 meissner@suse.com
- added missing %%service_add_pre with %%pre section
* Wed Feb 26 2014 hare@suse.de
- Update to latest upstream version 1.0.44 (FATE#316717):
  * Add sheepdog support
  * Add rbd support
  * Update iSER support
  * Add support for iSCSI NOP-OUT
  * SPC/SBC fixes
  * iSCSI fixes
  * Fixup persistent group reservations
- Removed tgt-mgmt-fixed-m-system-o-delete-handling.patch:
  Merged with upstream
- Removed tgt-1.0.28.tar.bz2
- Added tgt-1.0.44.tar.bz2
* Tue Jan 28 2014 werner@suse.de
- Make service link a local one
* Wed Oct 23 2013 p.drouand@gmail.com
- Drop sysvinit support
- Add systemd support
* Sat Jul 13 2013 dmueller@suse.com
- add setup-tgt-conf-d.patch: Configure a /etc/tgt/conf.d by default
- move examples to docdir
* Thu Apr 11 2013 lduncan@suse.com
- Renamed firewall service file from iscsitarget to tgt
  to remove conflict with tgt package (bnc#814364)
* Fri Oct 26 2012 lduncan@suse.com
- Add tgt-mgmt-fixed-m-system-o-delete-handling.patch: Fixes
  shutdown hang (bnc#767438)
- Removed PIDFILE completely from init file, as it is not used
* Tue Jul 10 2012 cfarrell@suse.com
- license update: GPL-2.0
  Most of the source code files carry a GPL-2.0 notice, not GPL-2.0+
* Thu Jun 14 2012 vuntz@opensuse.org
- Remove "# pidfile: /var/run/tgtd.pid" from tgt.init, as it makes
  the script hang on systemd-based systems. This is the same bug as
  rh#797913, and the fix was used in Fedora. Apparently, there's no
  such pid file written by tgtd.
* Mon Jun  4 2012 hare@suse.de
- Update to latest upstream release 1.0.23
  * Improved SCSI emulation
  * Various small fixes
* Mon Sep 21 2009 dmueller@suse.de
- require perl-Config-General (bnc#474129)
- add rc-symlink (bnc#474136)
* Thu Oct  9 2008 hare@suse.de
- Update to latest upstream release 0.9.0
  * tgt-admin fixes
  * add null backing store
  * Improve iSER scheduling
  * Various small fixes
* Mon Sep 15 2008 hare@suse.de
- Include fixes from upstream:
  * Add support to update targets
  * tgtadm fixes
  * Add PREVENT ALLOW MEDIA REMOVAL to ssc
  * Add MANAGEMENT PROTOCOL IN to ssc
  * Update README
- Fix rpmlint errors
* Fri Aug  8 2008 hare@suse.de
- Update to latest released version 20080805
  * Include FCP backend
  * Include FCoE backend
  * Bugfixes
* Thu Aug  9 2007 olh@suse.de
- remove inclusion of linux/hash.h, include it directly
* Wed Apr  4 2007 hare@suse.de
- Added service definition for SUSEFirewall2 (#251679)
* Wed Apr  4 2007 hare@suse.de
- Initial version svn r849
- Update to latest git version
- Fixes for build on openSUSE
